<!doctype html>
<html>

<head>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.3/Chart.bundle.js"></script>
</head>

<body>
  <div style="width:100%;">
    <canvas id="canvas"></canvas>
  </div>
  <br>
  <form>
  <input type="radio" id="kernel" name="mode" value="kernel" checked="checked">
  <label for="kernel">Compare kernel execution time</label>
  <br>
  <input type="radio" id="kernel_tvs1" name="mode" value="kernel_tvs1">
  <label for="kernel_tvs1">Compare kernel execution time (no tangent vector mode)</label>
  <br>
  <input type="radio" id="kernel_tvs4" name="mode" value="kernel_tvs4">
  <label for="kernel_tvs4">Compare kernel execution time (tvs 4)</label>
  <br>
  <input type="radio" id="kernel_tvs16" name="mode" value="kernel_tvs16">
  <label for="kernel_tvs16">Compare kernel execution time (tvs 16)</label>
  <br>
  <input type="radio" id="kernel_tvs64" name="mode" value="kernel_tvs64">
  <label for="kernel_tvs64">Compare kernel execution time (tvs 64)</label>
  <br>
  <input type="radio" id="stages" name="mode" value="stages">
  <label for="stages">Compare stages</label>
  </form>
  <br>
  <input type="file" id="input" accept=".json"/>
  <script>
    const ctx = document.getElementById('canvas').getContext('2d');
    const input = document.getElementById('input');
    var cfg;
    var metaData;
    
    window.onload = function(event) {
      cfg = {
        type: 'bar',
        data: {
          labels: [],
          datasets: [{
            data: []
          }]
        },
        options: {
          legend: {
            display: false
          }
        }
      };
      window.myLine = new Chart(ctx, cfg);
    }

    input.onchange = function(event) {
      if (event.target.files.length == 0) return;
      readFiles(event.target.files);
    }

    function readFiles(list){
      jsonData = [];
      var promises = [];
      for (var file of list) {
        var filePromise = new Promise(resolve => {
          var reader = new FileReader();
          reader.readAsText(file);
          reader.onload = () => resolve(reader.result);
        });
        promises.push(filePromise);
      }
      Promise.all(promises).then(fileContents => {
        var rawDataSets = [];
        for (var i = 0; i < fileContents.length; ++i) {
          rawDataSets[i] = JSON.parse(fileContents[i]);
        }
        generateChart(rawDataSets);
      });
    }

    function generateChart(rawDataSets) {
      var set = rawDataSets[0].benchmarks;
      var _reference = [];
      var _custom = [];
      var _separate = [];
      for (var i = 0; i < set.length; ++i) {
        var info = parseBenchmarkName(set[i].name);
        if (info.name == "BM_MATMUL_SEPARATE") {
          _separate.push([info,set[i]]);
        }
        else if (info.kernel == "matmul_reference") {
          _reference.push([info,set[i]]);
        }
        else {
          _custom.push([info,set[i]]);
        }
      }
      cfg.data.labels = [];
      cfg.data.datasets = [];
      if (document.getElementById("kernel").checked) {
        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";
        for (var i = 0; i < 20; ++i) {
          cfg.data.labels[i] = _reference[i][0].typeA+", "+_reference[i][0].typeB;
          disp1.data[i] = _reference[i][1].kernel;
          disp2.data[i] = _custom[i][1].kernel;
          if (i >= 4 && i <= 11) {
            disp3.data[i] = _separate[i-4][1].kernel;
          } else {
            disp3.data[i] = 0;
          }
        }
        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of kernel runtimes"
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else if (document.getElementById("kernel_tvs1").checked) {
        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";
        for (var i = 0; i < 8; ++i) {
          if (i == 5) i = 8;
          if (i == 9) i = 12;
          if (i == 13) i = 16;
          cfg.data.labels.push(_reference[i][0].typeA+", "+_reference[i][0].typeB);
          disp1.data.push(_reference[i][1].kernel);
          disp2.data.push(_custom[i][1].kernel);
          if (i >= 4 && i <= 11) {
            disp3.data.push(_separate[i-4][1].kernel);
          } else {
            disp3.data.push(0);
          }
        }
        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            //type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of kernel runtimes"
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else if (document.getElementById("kernel_tvs4").checked) {
        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";

        cfg.data.labels.push(_reference[5][0].typeA+", "+_reference[5][0].typeB);
        cfg.data.labels.push(_reference[9][0].typeA+", "+_reference[9][0].typeB);
        cfg.data.labels.push(_reference[13][0].typeA+", "+_reference[13][0].typeB);
        cfg.data.labels.push(_reference[17][0].typeA+", "+_reference[17][0].typeB);
        disp1.data.push(_reference[5][1].kernel);
        disp1.data.push(_reference[9][1].kernel);
        disp1.data.push(_reference[13][1].kernel);
        disp1.data.push(_reference[17][1].kernel);
        disp2.data.push(_custom[5][1].kernel);
        disp2.data.push(_custom[9][1].kernel);
        disp2.data.push(_custom[13][1].kernel);
        disp2.data.push(_custom[17][1].kernel);
        disp3.data.push(_separate[1][1].kernel);
        disp3.data.push(_separate[5][1].kernel);
        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            //type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of kernel runtimes"
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else if (document.getElementById("kernel_tvs16").checked) {
        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";

        cfg.data.labels.push(_reference[6][0].typeA+", "+_reference[6][0].typeB);
        cfg.data.labels.push(_reference[10][0].typeA+", "+_reference[10][0].typeB);
        cfg.data.labels.push(_reference[14][0].typeA+", "+_reference[14][0].typeB);
        cfg.data.labels.push(_reference[18][0].typeA+", "+_reference[18][0].typeB);
        disp1.data.push(_reference[6][1].kernel);
        disp1.data.push(_reference[10][1].kernel);
        disp1.data.push(_reference[14][1].kernel);
        disp1.data.push(_reference[18][1].kernel);
        disp2.data.push(_custom[6][1].kernel);
        disp2.data.push(_custom[10][1].kernel);
        disp2.data.push(_custom[14][1].kernel);
        disp2.data.push(_custom[18][1].kernel);
        disp3.data.push(_separate[2][1].kernel);
        disp3.data.push(_separate[6][1].kernel);
        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            //type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of kernel runtimes"
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else if (document.getElementById("kernel_tvs64").checked) {
        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";

        cfg.data.labels.push(_reference[7][0].typeA+", "+_reference[7][0].typeB);
        cfg.data.labels.push(_reference[11][0].typeA+", "+_reference[11][0].typeB);
        cfg.data.labels.push(_reference[15][0].typeA+", "+_reference[15][0].typeB);
        cfg.data.labels.push(_reference[19][0].typeA+", "+_reference[19][0].typeB);
        disp1.data.push(_reference[7][1].kernel);
        disp1.data.push(_reference[11][1].kernel);
        disp1.data.push(_reference[15][1].kernel);
        disp1.data.push(_reference[19][1].kernel);
        disp2.data.push(_custom[7][1].kernel);
        disp2.data.push(_custom[11][1].kernel);
        disp2.data.push(_custom[15][1].kernel);
        disp2.data.push(_custom[19][1].kernel);
        disp3.data.push(_separate[3][1].kernel);
        disp3.data.push(_separate[7][1].kernel);
        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            //type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of kernel runtimes"
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else if (document.getElementById("stages").checked) {
        var focused = 9; // focus on td4, td4

        var disp1 = {};
        var disp2 = {};
        var disp3 = {};
        disp1.data = [];
        disp2.data = [];
        disp3.data = [];
        disp1.backgroundColor = "seagreen";
        disp2.backgroundColor = "tomato";
        disp3.backgroundColor = "steelblue";

        cfg.data.labels.push("init");
        cfg.data.labels.push("cp2d");
        cfg.data.labels.push("kernel");
        cfg.data.labels.push("cp2h");
        disp1.data.push(_reference[focused][1].init);
        disp1.data.push(_reference[focused][1].cp2d);
        disp1.data.push(_reference[focused][1].kernel);
        disp1.data.push(_reference[focused][1].cp2h);
        disp2.data.push(_custom[focused][1].init);
        disp2.data.push(_custom[focused][1].cp2d);
        disp2.data.push(_custom[focused][1].kernel);
        disp2.data.push(_custom[focused][1].cp2h);
        disp3.data.push(_separate[focused-4][1].init);
        disp3.data.push(_separate[focused-4][1].cp2d);
        disp3.data.push(_separate[focused-4][1].kernel);
        disp3.data.push(_separate[focused-4][1].cp2h);

        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as 'type of A, type of B'"
            }
          }],
          yAxes: [{
            type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of stage times " + _reference[focused][0].typeA+", "+_reference[focused][0].typeB
        }
        disp1.label = "reference kernel";
        disp2.label = "custom kernel";
        disp3.label = "separate tangent matrix";
        cfg.data.datasets[0] = disp1;
        cfg.data.datasets[1] = disp2;
        cfg.data.datasets[2] = disp3;
      }
      else {
        return;
      }
      document.getElementById("kernel").disabled = true;
      document.getElementById("kernel_tvs1").disabled = true;
      document.getElementById("kernel_tvs4").disabled = true;
      document.getElementById("kernel_tvs16").disabled = true;
      document.getElementById("kernel_tvs64").disabled = true;
      document.getElementById("stages").disabled = true;
      window.myLine.update();
    }

    function parseBenchmarkName(name) {
      var _name = name.substr(0, name.indexOf('<'));
      var _param_string = name.substr(name.indexOf('<')+1, name.length);
      var _param_string = _param_string.substr(0, _param_string.indexOf('>/'));
      var _params = _param_string.split(', ');

      var ret;
      if (_name == "BM_MATMUL") {
        ret = {
          name:   _name,
          typeA:  _params[0],
          tvsA:   '0',
          typeB:  _params[1],
          tvsB:   '0',
          kernel: _params[2].substr(_params[2].indexOf('::')+2, _params[2].length),
          dim:    _params[3],
          block_size_x: _params[4],
          block_size_y: _params[5]
        }
      }
      else if (_name == "BM_MATMUL_SEPARATE") {
        ret = {
          name:   _name,
          typeA:  _params[0],
          tvsA:   _params[1],
          typeB:  _params[2],
          tvsB:   _params[3],
          kernel: _params[4].substr(_params[4].indexOf('::')+2, _params[4].length),
          dim: _params[5],
          block_size_x: _params[6],
          block_size_y: _params[7]
        }
      }
      else {
        return {};
      }
      ret.typeA = replaceType(ret.typeA);
      ret.typeB = replaceType(ret.typeB);
      return ret;
    }

    function replaceType(type) {
      switch (type) {
        case 'float': return 'f';
        case 'double': return 'd';
        case 'ml_cuda::interval_t<float>': return 'if';
        case 'ml_cuda::interval_t<double>': return 'id';
        case 'ml_cuda::tangent_t<float>': return 'tf';
        case 'ml_cuda::tangent_t<float,4>': return 'tf4';
        case 'ml_cuda::tangent_t<float,16>': return 'tf16';
        case 'ml_cuda::tangent_t<float,64>': return 'tf64';
        case 'ml_cuda::tangent_t<double>': return 'td';
        case 'ml_cuda::tangent_t<double,4>': return 'td4';
        case 'ml_cuda::tangent_t<double,16>': return 'td16';
        case 'ml_cuda::tangent_t<double,64>': return 'td64';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float>>': return 'itf';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,4>>': return 'itf4';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,16>>': return 'itf16';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<float,64>>': return 'itf64';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double>>': return 'itd';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,4>>': return 'itd4';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,16>>': return 'itd16';
        case 'ml_cuda::interval_t<ml_cuda::tangent_t<double,64>>': return 'itd64';
        default: break;
      }
      return 'no_type';
    }
  </script>
</body>

</html>
